The form shown in the Edit Panel is built with the Studio form builder. It configures the data and format settings for both custom widgets and, through a Widget Override, the built-in widgets.
import {
AgReportState,
AgStudioApi,
AgStudioProperties,
AgWidgetFormParams,
createStudio,
createWidgets,
enableStudioDevValidations,
} from "ag-studio";
import { CustomWidget } from "./customWidget.ts";
import { CustomDef, MyRegistry } from "./interfaces.ts";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableStudioDevValidations();
}
const initialState: AgReportState<MyRegistry> = {
pages: [
{
id: "page1",
widgets: {
"1": {
type: "customWidget",
dataMapping: {
value: [
{
id: "medals.gold",
aggregation: "sum",
},
],
},
},
},
widgetLayout: {
"1": {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 12,
},
},
selection: {
type: "widget",
id: "1",
},
},
],
selectedPageId: "page1",
panels: {
filters: {
collapsed: true,
},
data: {
collapsed: true,
},
},
};
const widgets = createWidgets<MyRegistry>({
additionalTypes: [
{
id: "customWidget",
icon: {
url: "https://www.ag-grid.com/studio/images/brandmark.svg",
},
label: "Custom Widget",
dataMapping: {
value: {
type: "field",
supportedRoles: ["numeric"],
requires: { cardinality: "one" },
required: true,
},
},
form: (params: AgWidgetFormParams<CustomDef>) => {
const defaultForm = params.createDefaults({
dataMappingItems: [
{
key: "value",
label: "Value",
},
],
});
defaultForm.items[0].items.push({
type: "section",
key: "customSection",
label: "Special Config",
items: [
{
type: "number",
id: "format.style.valueFontSize",
label: "Value Font Size",
defaultValue: 48,
},
],
});
return defaultForm;
},
comp: CustomWidget,
defaultSize: {
width: 400,
height: 300,
},
minSize: {
width: 200,
height: 100,
},
ai: {
description:
"Custom widget used for displaying values in an interesting way.",
},
},
],
menu: [
{
label: "Custom",
widgetIds: ["customWidget"],
},
],
});
const studioProperties: AgStudioProperties<MyRegistry> = {
mode: "edit",
initialState,
widgets,
};
let studioApi: AgStudioApi<MyRegistry>;
// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);
fetch("https://www.ag-grid.com/studio/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data) =>
studioApi!.setProperty("data", { sources: [{ id: "medals", data }] }),
);
The example above adds a Special Config section to the setup tab, with an input to control the font size of the value in the custom widget.
The form is provided via the form property of the widget definition.
Form configuration using typed form builder.
|
Form Setup Copy Link
The ID of each form item is a dot delimited path of the corresponding property within the widget config.
interface CustomWidgetStyle {
valueFontSize?: number;
}
interface CustomWidgetDef {
type: 'customWidget';
dataMapping: {
value: AgWidgetFieldReference[];
};
format?: AgWidgetDataFormat<CustomWidgetStyle>;
}For the above definition, the corresponding input ID for the valueFontSize property would be format.style.valueFontSize.
Form Helpers Copy Link
The form callback provides some helper functions to create form elements for the default properties (e.g. data mapping, titles, etc.).
const widgetDefinition = {
// ...
form: (params) => {
return params.createDefaults({
dataMappingItems: [
{
key: 'value',
label: 'Value',
},
],
});
},
} Create the default tab group with a setup and format tab. Setup tab contains: |
Creates a section containing the widget type selector.
|
Create the data mapping item. Either a section if multiple data mapping fields, or a single fieldset or field item.
|
Creates a section containing the cross filter input.
|
Creates the title section containing the title, subtitle and caption group.
|
Creates the widget appearance section, containing the background, corner radius and border controls. The built-in widgets place it in the format tab, directly below the titles section. The widget's formatShape must declare a widget property of type AgWidgetAppearance for the section to work - a format shape drops the fields it does not declare, so a widget that omits it shows controls whose values are forgotten on the next reload.
|
Form Default Values Copy Link
Each form item has a default value assigned. This is what you see when there is no state set. When using the reset to default button for a section, these are the values that the form section will be reset to (rather than those in initialState/the last state set).
Update the form items to change the default values.
Form Grouping Items Copy Link
The following form items allow for grouping/structuring the form items (e.g. they have children).
| Item | Interface | Description |
|---|---|---|
| Tab Group | AgWidgetFormTabGroup / AgFormTabGroup | A group of tab items. E.g. the top-level Setup / Format tab group in the edit panel for the default widgets. |
| Tab | AgWidgetFormTab / AgFormTab | A child tab of a tab group item. E.g. the Setup tab in the edit panel for the default widgets. |
| Section | AgWidgetFormSection / AgFormSection | A top-level collection of items. E.g. the Titles section in the edit panel for the default widgets. |
| Group | AgWidgetFormGroup / AgFormGroup | A lower-level collection of items (with an optional toggle). E.g. the Title group in the edit panel for the default widgets. |
Form Input Items Copy Link
| Item | Interface | Description |
|---|---|---|
| Select | AgWidgetFormSelect / AgFormSelect | A select input item. |
| Checkbox | AgWidgetFormCheckbox / AgFormCheckbox | A checkbox input item. |
| Toggle | AgWidgetFormToggle / AgFormToggle | A toggle input item. |
| Text Input | AgWidgetFormTextField / AgFormTextField | A text input item. |
| Text Area | AgWidgetFormTextArea / AgFormTextArea | A text area input item. |
| Number Input | AgWidgetFormNumber / AgFormNumber | A number input item. |
| Optional Number Input | AgWidgetFormOptionalNumber / AgFormOptionalNumber | A number input item that allows optional values. |
| Color Input | AgWidgetFormColor / AgFormColor | A color picker input item. |
| Widget Type Selector | AgWidgetFormWidgetType (widget form only) | A select input that allows changing the widget type. |
| Field Selection Input | AgWidgetFormField (widget form only) | An input for selecting a field (supporting drag and drop). |
| Fieldset Selection Input | AgWidgetFormFieldSet (widget form only) | An input for selecting multiple fields (supporting drag and drop). |
| Grouped Typography Input | AgWidgetFormTypography (widget form only) | A group of elements for configuring typography. |

The form shown in the Edit Panel is built with the Studio form builder. It configures the data and format settings for both custom widgets and, through a Widget Override, the built-in widgets.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
AgDataEngine,
AgDataSourcesDefinition,
AgDefaultRegistry,
AgReportState,
AgStudioApi,
AgStudioApiReadyEvent,
AgStudioMode,
AgStudioProperties,
AgWidgetFormParams,
AgWidgetsConfig,
enableStudioDevValidations,
} from "ag-studio";
import { createWidgets } from "ag-studio-vue3";
import CustomWidget from "./customWidgetVue.ts";
import { CustomDef, MyRegistry } from "./interfaces.ts";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableStudioDevValidations();
}
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div style="display: flex; flex-direction: column; height: 100%">
<ag-studio
style="width: 100%; height: 100%;"
class="my-studio-container"
@api-ready="onApiReady"
:initialState="initialState"
:widgets="widgets"
:mode="mode"
:data="data"></ag-studio>
</div>
</div>
`,
components: {
"ag-studio": AgStudio,
CustomWidget,
},
setup(props) {
const studioApi = shallowRef<AgStudioApi<MyRegistry> | null>(null);
const initialState = ref<AgReportState<MyRegistry>>({
pages: [
{
id: "page1",
widgets: {
"1": {
type: "customWidget",
dataMapping: {
value: [
{
id: "medals.gold",
aggregation: "sum",
},
],
},
},
},
widgetLayout: {
"1": {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 12,
},
},
selection: {
type: "widget",
id: "1",
},
},
],
selectedPageId: "page1",
panels: {
filters: {
collapsed: true,
},
data: {
collapsed: true,
},
},
});
const widgets = ref<
| AgWidgetsConfig<MyRegistry>
| ((
widgets: AgWidgetsConfig<AgDefaultRegistry>,
) => AgWidgetsConfig<MyRegistry>)
>(
createWidgets<MyRegistry>({
additionalTypes: [
{
id: "customWidget",
icon: {
url: "https://www.ag-grid.com/studio/images/brandmark.svg",
},
label: "Custom Widget",
dataMapping: {
value: {
type: "field",
supportedRoles: ["numeric"],
requires: { cardinality: "one" },
required: true,
},
},
form: (params: AgWidgetFormParams<CustomDef>) => {
const defaultForm = params.createDefaults({
dataMappingItems: [
{
key: "value",
label: "Value",
},
],
});
defaultForm.items[0].items.push({
type: "section",
key: "customSection",
label: "Special Config",
items: [
{
type: "number",
id: "format.style.valueFontSize",
label: "Value Font Size",
defaultValue: 48,
},
],
});
return defaultForm;
},
comp: "CustomWidget",
defaultSize: {
width: 400,
height: 300,
},
minSize: {
width: 200,
height: 100,
},
ai: {
description:
"Custom widget used for displaying values in an interesting way.",
},
},
],
menu: [
{
label: "Custom",
widgetIds: ["customWidget"],
},
],
}),
);
const mode = ref<AgStudioMode>("edit");
const data = ref<AgDataSourcesDefinition | AgDataEngine>(null);
const onApiReady = (params: AgStudioApiReadyEvent) => {
studioApi.value = params.api;
const toStudioData = (data) => ({ sources: [{ id: "medals", data }] });
fetch("https://www.ag-grid.com/studio/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((respData) => (data.value = toStudioData(respData)));
};
return {
studioApi,
initialState,
widgets,
mode,
data,
onApiReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
The example above adds a Special Config section to the setup tab, with an input to control the font size of the value in the custom widget.
The form is provided via the form property of the widget definition.
Form configuration using typed form builder.
|
Form Setup Copy Link
The ID of each form item is a dot delimited path of the corresponding property within the widget config.
interface CustomWidgetStyle {
valueFontSize?: number;
}
interface CustomWidgetDef {
type: 'customWidget';
dataMapping: {
value: AgWidgetFieldReference[];
};
format?: AgWidgetDataFormat<CustomWidgetStyle>;
}For the above definition, the corresponding input ID for the valueFontSize property would be format.style.valueFontSize.
Form Helpers Copy Link
The form callback provides some helper functions to create form elements for the default properties (e.g. data mapping, titles, etc.).
const widgetDefinition = {
// ...
form: (params) => {
return params.createDefaults({
dataMappingItems: [
{
key: 'value',
label: 'Value',
},
],
});
},
} Create the default tab group with a setup and format tab. Setup tab contains: |
Creates a section containing the widget type selector.
|
Create the data mapping item. Either a section if multiple data mapping fields, or a single fieldset or field item.
|
Creates a section containing the cross filter input.
|
Creates the title section containing the title, subtitle and caption group.
|
Creates the widget appearance section, containing the background, corner radius and border controls. The built-in widgets place it in the format tab, directly below the titles section. The widget's formatShape must declare a widget property of type AgWidgetAppearance for the section to work - a format shape drops the fields it does not declare, so a widget that omits it shows controls whose values are forgotten on the next reload.
|
Form Default Values Copy Link
Each form item has a default value assigned. This is what you see when there is no state set. When using the reset to default button for a section, these are the values that the form section will be reset to (rather than those in initialState/the last state set).
Update the form items to change the default values.
Form Grouping Items Copy Link
The following form items allow for grouping/structuring the form items (e.g. they have children).
| Item | Interface | Description |
|---|---|---|
| Tab Group | AgWidgetFormTabGroup / AgFormTabGroup | A group of tab items. E.g. the top-level Setup / Format tab group in the edit panel for the default widgets. |
| Tab | AgWidgetFormTab / AgFormTab | A child tab of a tab group item. E.g. the Setup tab in the edit panel for the default widgets. |
| Section | AgWidgetFormSection / AgFormSection | A top-level collection of items. E.g. the Titles section in the edit panel for the default widgets. |
| Group | AgWidgetFormGroup / AgFormGroup | A lower-level collection of items (with an optional toggle). E.g. the Title group in the edit panel for the default widgets. |
Form Input Items Copy Link
| Item | Interface | Description |
|---|---|---|
| Select | AgWidgetFormSelect / AgFormSelect | A select input item. |
| Checkbox | AgWidgetFormCheckbox / AgFormCheckbox | A checkbox input item. |
| Toggle | AgWidgetFormToggle / AgFormToggle | A toggle input item. |
| Text Input | AgWidgetFormTextField / AgFormTextField | A text input item. |
| Text Area | AgWidgetFormTextArea / AgFormTextArea | A text area input item. |
| Number Input | AgWidgetFormNumber / AgFormNumber | A number input item. |
| Optional Number Input | AgWidgetFormOptionalNumber / AgFormOptionalNumber | A number input item that allows optional values. |
| Color Input | AgWidgetFormColor / AgFormColor | A color picker input item. |
| Widget Type Selector | AgWidgetFormWidgetType (widget form only) | A select input that allows changing the widget type. |
| Field Selection Input | AgWidgetFormField (widget form only) | An input for selecting a field (supporting drag and drop). |
| Fieldset Selection Input | AgWidgetFormFieldSet (widget form only) | An input for selecting multiple fields (supporting drag and drop). |
| Grouped Typography Input | AgWidgetFormTypography (widget form only) | A group of elements for configuring typography. |

The form shown in the Edit Panel is built with the Studio form builder. It configures the data and format settings for both custom widgets and, through a Widget Override, the built-in widgets.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgStudio } from "ag-studio-angular";
import {
AgDataEngine,
AgDataSourcesDefinition,
AgDefaultRegistry,
AgReportState,
AgStudioApi,
AgStudioApiReadyEvent,
AgStudioMode,
AgStudioProperties,
AgWidgetFormParams,
AgWidgetsConfig,
enableStudioDevValidations,
} from "ag-studio";
import { CustomDef, MyRegistry } from "./interfaces.ts";
import { createWidgets } from "ag-studio-angular";
import { CustomWidget } from "./custom-widget.component.ts";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableStudioDevValidations();
}
@Component({
selector: "my-app",
standalone: true,
imports: [AgStudio, CustomWidget],
template: `<div style="display: flex; flex-direction: column; height: 100%">
<ag-studio
style="width: 100%; height: 100%;"
class="my-studio-container"
[initialState]="initialState"
[widgets]="widgets"
[mode]="mode"
[data]="data"
(apiReady)="onApiReady($event)"
/>
</div> `,
})
export class AppComponent {
initialState: AgReportState<MyRegistry> = {
pages: [
{
id: "page1",
widgets: {
"1": {
type: "customWidget",
dataMapping: {
value: [
{
id: "medals.gold",
aggregation: "sum",
},
],
},
},
},
widgetLayout: {
"1": {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 12,
},
},
selection: {
type: "widget",
id: "1",
},
},
],
selectedPageId: "page1",
panels: {
filters: {
collapsed: true,
},
data: {
collapsed: true,
},
},
};
widgets:
| AgWidgetsConfig<MyRegistry>
| ((
widgets: AgWidgetsConfig<AgDefaultRegistry>,
) => AgWidgetsConfig<MyRegistry>) = createWidgets<MyRegistry>({
additionalTypes: [
{
id: "customWidget",
icon: {
url: "https://www.ag-grid.com/studio/images/brandmark.svg",
},
label: "Custom Widget",
dataMapping: {
value: {
type: "field",
supportedRoles: ["numeric"],
requires: { cardinality: "one" },
required: true,
},
},
form: (params: AgWidgetFormParams<CustomDef>) => {
const defaultForm = params.createDefaults({
dataMappingItems: [
{
key: "value",
label: "Value",
},
],
});
defaultForm.items[0].items.push({
type: "section",
key: "customSection",
label: "Special Config",
items: [
{
type: "number",
id: "format.style.valueFontSize",
label: "Value Font Size",
defaultValue: 48,
},
],
});
return defaultForm;
},
comp: CustomWidget,
defaultSize: {
width: 400,
height: 300,
},
minSize: {
width: 200,
height: 100,
},
ai: {
description:
"Custom widget used for displaying values in an interesting way.",
},
},
],
menu: [
{
label: "Custom",
widgetIds: ["customWidget"],
},
],
});
mode: AgStudioMode = "edit";
constructor(private http: HttpClient) {}
onApiReady(params: AgStudioApiReadyEvent) {
this.http
.get("https://www.ag-grid.com/studio/example-assets/olympic-winners.json")
.subscribe((data) => (this.data = { sources: [{ id: "medals", data }] }));
}
}
The example above adds a Special Config section to the setup tab, with an input to control the font size of the value in the custom widget.
The form is provided via the form property of the widget definition.
Form configuration using typed form builder.
|
Form Setup Copy Link
The ID of each form item is a dot delimited path of the corresponding property within the widget config.
interface CustomWidgetStyle {
valueFontSize?: number;
}
interface CustomWidgetDef {
type: 'customWidget';
dataMapping: {
value: AgWidgetFieldReference[];
};
format?: AgWidgetDataFormat<CustomWidgetStyle>;
}For the above definition, the corresponding input ID for the valueFontSize property would be format.style.valueFontSize.
Form Helpers Copy Link
The form callback provides some helper functions to create form elements for the default properties (e.g. data mapping, titles, etc.).
const widgetDefinition = {
// ...
form: (params) => {
return params.createDefaults({
dataMappingItems: [
{
key: 'value',
label: 'Value',
},
],
});
},
} Create the default tab group with a setup and format tab. Setup tab contains: |
Creates a section containing the widget type selector.
|
Create the data mapping item. Either a section if multiple data mapping fields, or a single fieldset or field item.
|
Creates a section containing the cross filter input.
|
Creates the title section containing the title, subtitle and caption group.
|
Creates the widget appearance section, containing the background, corner radius and border controls. The built-in widgets place it in the format tab, directly below the titles section. The widget's formatShape must declare a widget property of type AgWidgetAppearance for the section to work - a format shape drops the fields it does not declare, so a widget that omits it shows controls whose values are forgotten on the next reload.
|
Form Default Values Copy Link
Each form item has a default value assigned. This is what you see when there is no state set. When using the reset to default button for a section, these are the values that the form section will be reset to (rather than those in initialState/the last state set).
Update the form items to change the default values.
Form Grouping Items Copy Link
The following form items allow for grouping/structuring the form items (e.g. they have children).
| Item | Interface | Description |
|---|---|---|
| Tab Group | AgWidgetFormTabGroup / AgFormTabGroup | A group of tab items. E.g. the top-level Setup / Format tab group in the edit panel for the default widgets. |
| Tab | AgWidgetFormTab / AgFormTab | A child tab of a tab group item. E.g. the Setup tab in the edit panel for the default widgets. |
| Section | AgWidgetFormSection / AgFormSection | A top-level collection of items. E.g. the Titles section in the edit panel for the default widgets. |
| Group | AgWidgetFormGroup / AgFormGroup | A lower-level collection of items (with an optional toggle). E.g. the Title group in the edit panel for the default widgets. |
Form Input Items Copy Link
| Item | Interface | Description |
|---|---|---|
| Select | AgWidgetFormSelect / AgFormSelect | A select input item. |
| Checkbox | AgWidgetFormCheckbox / AgFormCheckbox | A checkbox input item. |
| Toggle | AgWidgetFormToggle / AgFormToggle | A toggle input item. |
| Text Input | AgWidgetFormTextField / AgFormTextField | A text input item. |
| Text Area | AgWidgetFormTextArea / AgFormTextArea | A text area input item. |
| Number Input | AgWidgetFormNumber / AgFormNumber | A number input item. |
| Optional Number Input | AgWidgetFormOptionalNumber / AgFormOptionalNumber | A number input item that allows optional values. |
| Color Input | AgWidgetFormColor / AgFormColor | A color picker input item. |
| Widget Type Selector | AgWidgetFormWidgetType (widget form only) | A select input that allows changing the widget type. |
| Field Selection Input | AgWidgetFormField (widget form only) | An input for selecting a field (supporting drag and drop). |
| Fieldset Selection Input | AgWidgetFormFieldSet (widget form only) | An input for selecting multiple fields (supporting drag and drop). |
| Grouped Typography Input | AgWidgetFormTypography (widget form only) | A group of elements for configuring typography. |

The form shown in the Edit Panel is built with the Studio form builder. It configures the data and format settings for both custom widgets and, through a Widget Override, the built-in widgets.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
AgDataEngine,
AgDataSourcesDefinition,
AgDefaultRegistry,
AgReportState,
AgStudioApi,
AgStudioApiReadyEvent,
AgStudioMode,
AgStudioProperties,
AgWidgetFormParams,
AgWidgetsConfig,
enableStudioDevValidations,
} from "ag-studio";
import { CustomDef, MyRegistry } from "./interfaces.tsx";
import { createWidgets } from "ag-studio-react";
import CustomWidget from "./customWidget.tsx";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableStudioDevValidations();
}
const StudioExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [data, setData] = useState<AgDataSourcesDefinition | AgDataEngine>();
const initialState = useMemo<AgReportState<MyRegistry>>(() => {
return {
pages: [
{
id: "page1",
widgets: {
"1": {
type: "customWidget",
dataMapping: {
value: [
{
id: "medals.gold",
aggregation: "sum",
},
],
},
},
},
widgetLayout: {
"1": {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 12,
},
},
selection: {
type: "widget",
id: "1",
},
},
],
selectedPageId: "page1",
panels: {
filters: {
collapsed: true,
},
data: {
collapsed: true,
},
},
};
}, []);
const widgets = useMemo<
| AgWidgetsConfig<MyRegistry>
| ((
widgets: AgWidgetsConfig<AgDefaultRegistry>,
) => AgWidgetsConfig<MyRegistry>)
>(() => {
return createWidgets<MyRegistry>({
additionalTypes: [
{
id: "customWidget",
icon: {
url: "https://www.ag-grid.com/studio/images/brandmark.svg",
},
label: "Custom Widget",
dataMapping: {
value: {
type: "field",
supportedRoles: ["numeric"],
requires: { cardinality: "one" },
required: true,
},
},
form: (params: AgWidgetFormParams<CustomDef>) => {
const defaultForm = params.createDefaults({
dataMappingItems: [
{
key: "value",
label: "Value",
},
],
});
defaultForm.items[0].items.push({
type: "section",
key: "customSection",
label: "Special Config",
items: [
{
type: "number",
id: "format.style.valueFontSize",
label: "Value Font Size",
defaultValue: 48,
},
],
});
return defaultForm;
},
comp: CustomWidget,
defaultSize: {
width: 400,
height: 300,
},
minSize: {
width: 200,
height: 100,
},
ai: {
description:
"Custom widget used for displaying values in an interesting way.",
},
},
],
menu: [
{
label: "Custom",
widgetIds: ["customWidget"],
},
],
});
}, []);
const onApiReady = useCallback((params: AgStudioApiReadyEvent) => {
fetch("https://www.ag-grid.com/studio/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data: any[]) => setData({ sources: [{ id: "medals", data }] }));
}, []);
return (
<div style={containerStyle}>
<div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
<AgStudio<MyRegistry>
style={studioStyle}
className="my-studio-container"
data={data}
initialState={initialState}
widgets={widgets}
mode={"edit"}
onApiReady={onApiReady}
/>
</div>
</div>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<StudioExample />
</StrictMode>,
);
The example above adds a Special Config section to the setup tab, with an input to control the font size of the value in the custom widget.
The form is provided via the form property of the widget definition.
Form configuration using typed form builder.
|
Form Setup Copy Link
The ID of each form item is a dot delimited path of the corresponding property within the widget config.
interface CustomWidgetStyle {
valueFontSize?: number;
}
interface CustomWidgetDef {
type: 'customWidget';
dataMapping: {
value: AgWidgetFieldReference[];
};
format?: AgWidgetDataFormat<CustomWidgetStyle>;
}For the above definition, the corresponding input ID for the valueFontSize property would be format.style.valueFontSize.
Form Helpers Copy Link
The form callback provides some helper functions to create form elements for the default properties (e.g. data mapping, titles, etc.).
const widgetDefinition = {
// ...
form: (params) => {
return params.createDefaults({
dataMappingItems: [
{
key: 'value',
label: 'Value',
},
],
});
},
} Create the default tab group with a setup and format tab. Setup tab contains: |
Creates a section containing the widget type selector.
|
Create the data mapping item. Either a section if multiple data mapping fields, or a single fieldset or field item.
|
Creates a section containing the cross filter input.
|
Creates the title section containing the title, subtitle and caption group.
|
Creates the widget appearance section, containing the background, corner radius and border controls. The built-in widgets place it in the format tab, directly below the titles section. The widget's formatShape must declare a widget property of type AgWidgetAppearance for the section to work - a format shape drops the fields it does not declare, so a widget that omits it shows controls whose values are forgotten on the next reload.
|
Form Default Values Copy Link
Each form item has a default value assigned. This is what you see when there is no state set. When using the reset to default button for a section, these are the values that the form section will be reset to (rather than those in initialState/the last state set).
Update the form items to change the default values.
Form Grouping Items Copy Link
The following form items allow for grouping/structuring the form items (e.g. they have children).
| Item | Interface | Description |
|---|---|---|
| Tab Group | AgWidgetFormTabGroup / AgFormTabGroup | A group of tab items. E.g. the top-level Setup / Format tab group in the edit panel for the default widgets. |
| Tab | AgWidgetFormTab / AgFormTab | A child tab of a tab group item. E.g. the Setup tab in the edit panel for the default widgets. |
| Section | AgWidgetFormSection / AgFormSection | A top-level collection of items. E.g. the Titles section in the edit panel for the default widgets. |
| Group | AgWidgetFormGroup / AgFormGroup | A lower-level collection of items (with an optional toggle). E.g. the Title group in the edit panel for the default widgets. |
Form Input Items Copy Link
| Item | Interface | Description |
|---|---|---|
| Select | AgWidgetFormSelect / AgFormSelect | A select input item. |
| Checkbox | AgWidgetFormCheckbox / AgFormCheckbox | A checkbox input item. |
| Toggle | AgWidgetFormToggle / AgFormToggle | A toggle input item. |
| Text Input | AgWidgetFormTextField / AgFormTextField | A text input item. |
| Text Area | AgWidgetFormTextArea / AgFormTextArea | A text area input item. |
| Number Input | AgWidgetFormNumber / AgFormNumber | A number input item. |
| Optional Number Input | AgWidgetFormOptionalNumber / AgFormOptionalNumber | A number input item that allows optional values. |
| Color Input | AgWidgetFormColor / AgFormColor | A color picker input item. |
| Widget Type Selector | AgWidgetFormWidgetType (widget form only) | A select input that allows changing the widget type. |
| Field Selection Input | AgWidgetFormField (widget form only) | An input for selecting a field (supporting drag and drop). |
| Fieldset Selection Input | AgWidgetFormFieldSet (widget form only) | An input for selecting multiple fields (supporting drag and drop). |
| Grouped Typography Input | AgWidgetFormTypography (widget form only) | A group of elements for configuring typography. |